Ext.define('DSS.addon.TimeApartmentEditor', {
	extend : 'Ext.window.Window',
	editControls : {},
	buttonSave : null,
	buttonCancel : null,
	buttonRemove : null,
	value : null,
	setValue : function(oValue) {
		this.editControls['from'].suspendEvents();
		this.editControls['to'].suspendEvents();
		this.value = oValue;
		if (this.value.fromID == null)
			this.buttonRemove.setVisible(false);
		else
			this.buttonRemove.setVisible(true);
		if (this.value.from == null) {
			this.editControls['from'].setValue(null);
			this.editControls['from'].numHour.setRawValue(null);
			this.editControls['from'].numMinutes.setRawValue(null);
			this.editControls['from'].numSeconds.setRawValue(null);
		} else {
			this.editControls['from'].setValue(this.value.from % (24 * 60 * 60));
		}
		if (this.value.to == null) {
			this.editControls['to'].setValue(null);
			this.editControls['to'].numHour.setRawValue(null);
			this.editControls['to'].numMinutes.setRawValue(null);
			this.editControls['to'].numSeconds.setRawValue(null);
		} else {
			this.editControls['to'].setValue(this.value.to % (24 * 60 * 60));
		}
		this.editControls['from'].resumeEvents();
		this.editControls['to'].resumeEvents();
		switch (Math.floor(this.value.from / (24 * 60 * 60))) {
		case 0:
			this.editControls['weekdaySelectorStart'].setValue('MO');
			break;
		case 1:
			this.editControls['weekdaySelectorStart'].setValue('TU');
			break;
		case 2:
			this.editControls['weekdaySelectorStart'].setValue('WE');
			break;
		case 3:
			this.editControls['weekdaySelectorStart'].setValue('TH');
			break;
		case 4:
			this.editControls['weekdaySelectorStart'].setValue('FR');
			break;
		case 5:
			this.editControls['weekdaySelectorStart'].setValue('SA');
			break;
		case 6:
			this.editControls['weekdaySelectorStart'].setValue('SU');
			break;
		}
		switch (Math.floor(this.value.to / (24 * 60 * 60))) {
		case 0:
			this.editControls['weekdaySelectorEnd'].setValue('MO');
			break;
		case 1:
			this.editControls['weekdaySelectorEnd'].setValue('TU');
			break;
		case 2:
			this.editControls['weekdaySelectorEnd'].setValue('WE');
			break;
		case 3:
			this.editControls['weekdaySelectorEnd'].setValue('TH');
			break;
		case 4:
			this.editControls['weekdaySelectorEnd'].setValue('FR');
			break;
		case 5:
			this.editControls['weekdaySelectorEnd'].setValue('SA');
			break;
		case 6:
			this.editControls['weekdaySelectorEnd'].setValue('SU');
			break;
		}
	},
	getValue : function() {
		switch (this.editControls['weekdaySelectorStart'].getValue()) {
		case 'MO':
			this.value.from = 0 * 24 * 60 * 60;
			break;
		case 'TU':
			this.value.from = 1 * 24 * 60 * 60;
			break;
		case 'WE':
			this.value.from = 2 * 24 * 60 * 60;
			break;
		case 'TH':
			this.value.from = 3 * 24 * 60 * 60;
			break;
		case 'FR':
			this.value.from = 4 * 24 * 60 * 60;
			break;
		case 'SA':
			this.value.from = 5 * 24 * 60 * 60;
			break;
		case 'SU':
			this.value.from = 6 * 24 * 60 * 60;
			break;
		}
		switch (this.editControls['weekdaySelectorEnd'].getValue()) {
		case 'MO':
			this.value.to = 0 * 24 * 60 * 60;
			break;
		case 'TU':
			this.value.to = 1 * 24 * 60 * 60;
			break;
		case 'WE':
			this.value.to = 2 * 24 * 60 * 60;
			break;
		case 'TH':
			this.value.to = 3 * 24 * 60 * 60;
			break;
		case 'FR':
			this.value.to = 4 * 24 * 60 * 60;
			break;
		case 'SA':
			this.value.to = 5 * 24 * 60 * 60;
			break;
		case 'SU':
			this.value.to = 6 * 24 * 60 * 60;
			break;
		}
		this.value.from += this.editControls['from'].getValue();
		this.value.to += this.editControls['to'].getValue();
		return this.value;
	},
	constructor : function(config) {
		var me = this;
		this.value = {};
		config.closeAction = 'hide';
		config.modal = true;
		config.height = 150;
		config.width = 750;
		config.layout = 'fit';
		config.appName = '';
		config.resizable = false;
		config.title = _('Configure apartment mode settings for comfort');

		this.editControls['initial'] = Ext.create('Ext.panel.Panel', {
			html : '<span style="color:#005138;">' + _('select a period of comfort') + '</span>',
			width : 600,
			height : 25,
			border : false
		});
		
		var oWeekdaysStore= Ext.create('Ext.data.Store', {
		    fields: ['value', 'name'],
		    data : [
		        {"value":"MO", "name":_("MO")},
		        {"value":"TU", "name":_("TU")},
		        {"value":"WE", "name":_("WE")},
		        {"value":"TH", "name":_("TH")},
		        {"value":"FR", "name":_("FR")},
		        {"value":"SA", "name":_("SA")},
		        {"value":"SU", "name":_("SU")}
		    ]
		});
		
		this.editControls['weekdaySelectorStart']  = 
			Ext.create('Ext.form.field.ComboBox', {
				editable:false,
	            store: oWeekdaysStore,
	            queryMode: 'local',
	            displayField: 'name',
	            valueField: 'value',                               
	            fieldLabel : _('starting on day'),
	            labelWidth:230,
	            width : 300,
	            padding: "0 5 0 0"
	        });
		
		this.editControls['from'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 0,
			width : 400,
			hideSecond:true
		});
		
		this.editControls['weekdaySelectorEnd'] = 
			Ext.create('Ext.form.field.ComboBox', {
				editable:false,
	            store: oWeekdaysStore,
	            queryMode: 'local',
	            displayField: 'name',
	            valueField: 'value',                               
	            fieldLabel : _('ending on day'),
	            labelWidth:230,
	            width : 300,
	            padding: "0 5 0 0"
	        });
			

		this.editControls['to'] = Ext.create('DSS.component.TimeSpanControl', {
			labelWidth : 0,
			width : 400,
			hideSecond:true
		});

		me.buttonSave = Ext.create('Ext.Button', {
			text : _('save'),
			handler : function() {
				me.base.saveApartmentTime(me.getValue());
				me.hide();
			}
		});
		me.buttonCancel = Ext.create('Ext.Button', {
			text : _('cancel'),
			handler : function() {
				me.hide();
			}
		});
		me.buttonRemove = Ext.create('Ext.Button', {
			text : _('remove'),
			handler : function() {
				me.base.removeApartmentTime(me.getValue());
				me.hide();
			}
		});
		this.displayBottomText = Ext.create('Ext.form.field.Display', {
			border : 0,
			value : '',
			style : {
				fontSize : '11px'
			},
			padding : '0 0 2 5',
			flex : 1
		});
		var oButtons = [ me.buttonRemove, this.displayBottomText ];

		oButtons.push(me.buttonSave);
		oButtons.push(me.buttonCancel);
		Ext.apply(me, {
			items : [ {
				xtype : 'panel',
				items : [this.editControls['initial'],
				{
					border:false,
					xtype:'panel',
					layout:'hbox',
					items:[this.editControls['weekdaySelectorStart'],this.editControls['from']]
				},{
					border:false,
					xtype:'panel',
					layout:'hbox',
					items:[this.editControls['weekdaySelectorEnd'],this.editControls['to']]
				}],
				bodyPadding : 5,
				border : 0,
				dockedItems : [ {
					xtype : 'toolbar',
					dock : 'bottom',
					ui : 'footer',
					defaults : {
						minWidth : 75
					},
					items : oButtons
				} ]
			} ]
		}); // Ext.apply
		this.callParent(arguments);
	}
});
